from car_util import * # yeahhh don't do this
############
# rear_bumper
############

def rbumper_pts(t, offs):
    # base of bonnet
    base = []

    wpout = wpoints[-1]-0.05 # bring sides of back bumper in a bit

    # top line
    wp1 = wpoints[-2]-0.16
    wp0 = wpoints[1]-0.04
    wdiff = wp1 - wp0
    p = []
    for j, wd in enumerate([-wp1, -wp0, wp0, wp1]):
        pos = [wd+offs[0], back_fwd[-1]+offs[1], h2-0.04+offs[2]]
        p.append(pos)
        t.add_joint(pos)
    base.append(p)

    # middle rows
    p1 = []
    wp2 = wpoints[-1] - wdiff
    for i, d in enumerate([back_fwd[-1]-0.03, back_fwd[-2]]):
        p = []
        for j, wd in enumerate([-wpout, -wp2, wp2, wpout]):
            height = h1-0.04
            if i == 0:
                height += 0.04 # raise spoiler line slightly
                wd -= math.copysign(0.03, wd) # bring rear bumper in
            pos = [wd+offs[0], d+offs[1], height+offs[2]]
            p.append(pos)
            t.add_joint(pos)
        p1.append(p)
    base.append(p1)

    # bottom row
    p = []
    wp2 -= 0.05
    d = back_fwd[-1]-0.1
    for j, wd in enumerate([-wpoints[-2], -wp2, wp2, wpoints[-2]]):
        pos = [wd+offs[0], d+offs[1], h0+0.16+offs[2]]
        p.append(pos)
        t.add_joint(pos)
    base.append(p)

    return base

def rear_bumper(offs):
    t = Group()
    base = rbumper_pts(t, offs)

    def connect_straight(p):
        self.add_pipe(p[0], p[1])
        self.add_pipe(p[3], p[2])
    def connect_rows(p, p1):
        for j in range(len(p)):
            self.add_pipe(p[j], p1[j])
        connect_diags(p, p1)
    def connect_diags(p, p1):
        self.add_pipe(p[0], p1[1])
        self.add_pipe(p[3], p1[2])
    # connect row-to-row
    connect_rows(base[0], base[1][0])
    connect_rows(base[2], base[1][0])
    connect_rows(base[2], base[1][1])
    connect_rows(base[0], base[1][1])
    connect_rows(base[1][0], base[1][1])
    connect_straight(base[0])
    connect_straight(base[2])
    connect_straight(base[1][0])
    connect_straight(base[1][1])
    # lastly cross-bumper, top line
    self.add_pipe(base[0][1], base[0][2])

    return base, t

############
# rear_section
############

def rear_pts(t, bumper, offs):
    base = []

    # top line
    wp1 = wpoints[-2]-0.12
    wp0 = wp1 - 0.15
    wdiff = wp1 - wp0
    for j, wd in enumerate([-wp1, -wp0, wpoints[0], wp0, wp1]):
        if j == 2:
            height = h1+0.11
        else:
            height = h2-0.08
        pos = [wd+offs[0], back_fwd[-2]+offs[1]+0.03, height+offs[2]]
        base.append(pos)
        t.add_joint(pos)

    # centre line, runs from middle line down to bumper
    centre = []
    centre.append(pavg(bumper[1][1][1], bumper[1][1][2]))
    centre.append(pavg(bumper[2][1], bumper[2][2]))
    for pos in centre:
        t.add_joint(pos)

    return base, centre


class RearSection(Group):

    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def make(self, bumper_pts, rbox_pts, offs):
        roof, boxbase, midbox, midfront = rbox_pts
        base, centre = rear_pts(self, bumper_pts, offs)

        # connect across top line
        for i in range(len(base)-1):
            self.add_pipe(base[i], base[i+1])
        # connect top line to bumper
        for i in [0, -1]:
            self.add_pipe(base[i], bumper_pts[1][1][i])
            self.add_pipe(base[i], bumper_pts[0][i])
        for i in [0,1]:
            self.add_pipe(base[1], bumper_pts[0][i])
        for i in [-1,-2]:
            self.add_pipe(base[3], bumper_pts[0][i])
        for i in [0,1,2]:
            self.add_pipe(base[i], bumper_pts[1][1][1])
        for i in [2,3,4]:
            self.add_pipe(base[i], bumper_pts[1][1][-2])

        # set of diagonals across top part of bumper and backbox
        plist = []
        for i in [0, -1]:
            plist.append([bumper_pts[1][1][i], midbox[i], base[i]])
        for j, i in [(0, 1), (-1, -2)]:
            plist.append([midbox[j], bumper_pts[1][1][i]])
            plist.append([base[i], midbox[i], bumper_pts[1][1][i]])
        plist.append([midbox[2], base[2], midbox[1]])
        plist.append([roof[0], base[-1],roof[1], base[-2], roof[2]])
        plist.append([base[2], roof[3], base[-2]])
        plist.append([midbox[0], bumper_pts[1][1][0], roof[-1],
                     base[0], roof[-2],
                     base[1], roof[-3]])
        plist.append([base[-3], roof[-4], base[1]])
        plist.append([bumper_pts[0][1], base[2], bumper_pts[0][2]])
        # to lower part of bumper (these are really long)
        for i in [1, -2]:
            plist.append([bumper_pts[1][1][i], boxbase[i], bumper_pts[2][i]])

        # link all the above up...
        for pts in plist:
            for i in range(len(pts)-1):
                self.add_pipe(pts[i], pts[i+1])

        # now connect to mid-points
        plist = []
        plist.append((centre[0], (centre[1], bumper_pts[2][1], bumper_pts[2][2],
                                  base[2], midbox[1], midbox[2],
                                  bumper_pts[1][1][1], bumper_pts[1][1][2])))
        plist.append((centre[1], (bumper_pts[2][1], bumper_pts[2][2],
                                  boxbase[1], boxbase[2] # really long
                    )))
        for pt, pts in plist:
            for i in range(len(pts)):
                self.add_pipe(pt, pts[i])

        return base, t

        def connect_straight(p):
            self.add_pipe(p[0], p[1])
            self.add_pipe(p[3], p[2])
        def connect_rows(p, p1):
            for j in range(len(p)):
                self.add_pipe(p[j], p1[j])
            connect_diags(p, p1)
        def connect_diags(p, p1):
            self.add_pipe(p[0], p1[1])
            self.add_pipe(p[3], p1[2])
        # connect row-to-row
        connect_rows(base[0], base[1][0])
        connect_rows(base[2], base[1][0])
        connect_rows(base[2], base[1][1])
        connect_rows(base[0], base[1][1])
        connect_rows(base[1][0], base[1][1])
        connect_straight(base[0])
        connect_straight(base[2])
        connect_straight(base[1][0])
        connect_straight(base[1][1])
        # lastly cross-bumper, top line
        self.add_pipe(base[0][1], base[0][2])

        return [base, centre], t

